package local.ua.test;

import java.io.File;
import java.io.PipedOutputStream;
import java.util.Vector;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;

import local.ua.SSInBandDtmfDetector;
import local.ua.SSInBandDtmfInterface;

import org.apache.log4j.PropertyConfigurator;

public class DtmfDetectorTest implements SSInBandDtmfInterface
{
	private static Vector<Integer> foundDigits=new Vector<Integer>();

	public void gotDtmfDigit(int digit)
	{
		foundDigits.add(digit);
	}
	
	private void doTest()
	{
		
				String clipFile;
    	       // clipFile="testingclips/DTMF_tones_8k_16bit.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms_-32db.wav"; // starts to fail at this level
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms_-27db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms_-20db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms_-12db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms_-6db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_40ms.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_70ms.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_100ms_-6db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_100ms.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_200ms_-3db.wav";
		       //clipFile="testingclips/DTMF_tones_16k_16bit_200ms.wav";
			   //clipFile="testingclips/test_pcm_out.wav";
		       //clipFile="testingclips/test_pcm_out_0db.wav";
		      
				clipFile="testingclips/dtmf_mun.wav"; // has 10 digits
		       //clipFile="testingclips/dtmf_mun_1.wav"; // 11
		       //clipFile="testingclips/dtmf_mun_2.wav"; // 8
		       //clipFile="testingclips/dtmf_mun_3.wav"; // 8  - excess twist  
		       //clipFile="testingclips/dtmf_mun_4.wav"; // 0
		       //clipFile="testingclips/dtmf_mun_5.wav"; // 1
		       // clipFile="testingclips/dtmf_mun_6.wav"; // 7  - excess twist
		       // clipFile="testingclips/dtmf_mun_7.wav"; // 1 - excess twist
		       //clipFile="testingclips/dtmf_mun_8.wav"; // 6
		       //clipFile="testingclips/dtmf_mun_9.wav"; // 0 - excess twist
		       //clipFile="testingclips/dtmf_mun_10.wav"; // no detect - excess twist - really bad

		       //clipFile="testingclips/dtmf_mun_234.wav"; // sb 8,8,0
				
				clipFile="testingclips/1.wav"; //12 digits - got [1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 10, 11] Count=12
				//clipFile="testingclips/2.wav"; //12 digits - got [1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 10, 11] Count=12
				//clipFile="testingclips/3.wav"; //12 digits - got [1, 2, 2, 3, 5, 6, 7, 8, 8, 9, 10] Count=11
				//clipFile="testingclips/track05.wav";

	       	   
	       	   int ReadSize=640;
	       	   
	       	   AudioInputStream audStream=null;
			   try
			   {
		       	    PropertyConfigurator.configure("log_debug.properties");
		       	    
		       	    AudioFormat af=AudioSystem.getAudioFileFormat(new File(clipFile)).getFormat();
		       	    // default SSInBandDtmfDetector detector=new  SSInBandDtmfDetector(this,(int)af.getSampleRate(),af.getSampleSizeInBits()/8,30,40,1f,1f);
		       	    SSInBandDtmfDetector detector=new SSInBandDtmfDetector(this,(int)af.getSampleRate(),af.getSampleSizeInBits()/8,30,40,1f,.1f); // twist adjust between .063 to .1
		       	    PipedOutputStream dtmfDectorStream=new PipedOutputStream(detector.getPipedInputStream());
		       	    
		       	     
					System.out.println("clipFormat="+af.toString());
					
					byte data[] = new byte[ReadSize];
					
					audStream=AudioSystem.getAudioInputStream(new File(clipFile));

					 System.out.println("File:"+clipFile+" Opened");
			     
				     while (audStream.available()>=ReadSize)
				     {	   
		
				    	    audStream.read(data,0,ReadSize);
				    	    dtmfDectorStream.write(data,0,ReadSize);
				    	    try {Thread.sleep(1);} catch(Exception se){}
				     }
		    	     dtmfDectorStream.write(new byte[ReadSize],0,ReadSize);
				     dtmfDectorStream.flush();
				     Thread.sleep(60);
				     detector.stopDetecter();
			   }
			   catch (Exception e)
			   {
				   e.printStackTrace();
				   System.err.println("Error - Msg:"+e.getLocalizedMessage());
			   }
	       	   
			   System.out.println("\r\nFound digits: "+foundDigits.toString()+" Count="+foundDigits.size());
			   
			   System.exit(0);
	   }    


	/** for testing. */
	public static void main(String[] args) throws Exception 
	{
		DtmfDetectorTest dt=new DtmfDetectorTest();
		dt.doTest();
	}
		
}
